---
---

{% capture j1_cache %}

{% comment %}
 # -----------------------------------------------------------------------------
 #  J1: ~/assets/themes/j1/j1/js/adapters/tocbot.js
 #  JS/Liquid template to create the J1 Adapter for J1 Tocbot
 #
 #  Product/Info:
 #  https://jekyll.one
 #  https://tscanlin.github.io/tocbot
 #
 #  Copyright (C) 2016 Juergen Adams
 #
 #  J1 Template is licensed under the MIT License.
 #  For details, see https://jekyll.one
 #  Tocbot is licensed under under the MIT License.
 #  For details, see https://tscanlin.github.io/tocbot
 #
 # -----------------------------------------------------------------------------
{% endcomment %}

/*
 # -----------------------------------------------------------------------------
 #  J1: ~/assets/themes/j1/j1/js/adapters/tocbot.js
 #  JS Adapter for for J1 Tocbot
 #
 #  Product/Info:
 #  https://jekyll.one
 #  https://tscanlin.github.io/tocbot
 #
 #  Copyright (C) 2016 Juergen Adams
 #
 #  J1 Template is licensed under the MIT License.
 #  For details, see https://jekyll.one
 #  Tocbot is licensed under under the MIT License.
 #  For details, see https://tscanlin.github.io/tocbot
 #
 # -----------------------------------------------------------------------------
 #  Adapter generated: {{site.time}}
 # -----------------------------------------------------------------------------
*/

{% assign config_tocbot = site.data.modules.j1_tocbot %}

  var J1Tocbot = function () {
    "use strict";
    return {
        // Initialize
        init: function ( options ) {

          this.settings = $.extend({}, options);

          if ( this.settings.collapseDepth === undefined ) {
            this.settings.collapseDepth = {{config_tocbot.defaults.collapseDepth}};
          }

          if ( this.settings.scrollOptions === undefined ) {
            this.settings.scrollOffset = {{config_tocbot.defaults.scrollOptions.offset}};
          }

          if ( this.settings.enabled === undefined ) {
            this.settings.enabled = true;
          }          
        
          if ( this.settings.enabled == true) {      
                  this.tocbotInit();
                  this.initAffix();
                  this.setTop();
          }          

        },
        // ---------------------------------------------------------------------
        // Set Tocbot options
        // ---------------------------------------------------------------------
        tocbotInit: function () {
          tocbot.init({
            log:                    {{ config_tocbot.log | json }},
            tocSelector:            {{ config_tocbot.defaults.tocSelector | json }},
            headingSelector:        {{ config_tocbot.defaults.headingSelector | json }},
            ignoreSelector:         {{ config_tocbot.defaults.ignoreSelector | json }},
            contentSelector:        {{ config_tocbot.defaults.contentSelector | json }},
            collapseDepth:          this.settings.collapseDepth,
            throttleTimeout:        {{ config_tocbot.defaults.throttleTimeout | json }},
            smoothScrollOptions:    {
              easing:               {{ config_tocbot.defaults.scrollOptions.easing | json }},
              offset:               this.settings.scrollOffset,
              speed:                {{ config_tocbot.defaults.scrollOptions.speed | json }},
              updateURL:            {{ config_tocbot.defaults.scrollOptions.updateURL | json }}
                                    },
            includeHtml:            "false",
            headingsOffset:         -1,
            linkClass:              "toc-link",
            extraLinkClasses:       "",
            activeLinkClass:        "is-active-link",
            listClass:              "toc-list",
            extraListClasses:       "",
            isCollapsedClass:       "is-collapsed",
            collapsibleClass:       "is-collapsible",
            listItemClass:          "toc-list-item",
            positionFixedSelector:  "",
            positionFixedClass:     "is-position-fixed",
            fixedSidebarOffset:     "auto"
          });

          if (tocbot.options.log == true) {
            // Writes all of the current option settings to JS console
            console.log( tocbot.options );
          }
        },
        // ---------------------------------------------------------------------
        // Calculate|Set Affix offset Top|Bottom
        // ---------------------------------------------------------------------
        // ToDo: Calculation for top-position should use the id #j1-pagehead
        // instead of the class .j1-pagehead
        initAffix: function () {
            var sidebar = $("#j1-sidebar"),
                header  = $(".j1-pagehead");
            $(sidebar).affix({
              offset: {
                top: function() {
                  var c = $(sidebar).offset().top,
                    e = $('.nav').height(),
                    h = $(header).height(),
                    z = c - e;
                    return this.top = c - e
                  },
                bottom: function () {
                  var footer_offset = 100;
                  return ( this.bottom = $("#j1-footer").outerHeight(true) + footer_offset )
                }
              }
            });
        },
        // ---------------------------------------------------------------------
        // Calculate|Set Top position of the Tocbot menu
        // ---------------------------------------------------------------------
        setTop: function () {
            $(window).scroll(function(event){
              var navbar    = $("nav.navbar.bootsnav"),
                  pagehead  = $(".j1-pagehead"),
                  m         = parseInt(pagehead.css("margin-bottom"), 10),
                  n         = navbar.outerHeight(),
                  o         = n + m;
              if( navbar.hasClass("navbar-fixed")){
                $("#j1-sidebar.affix").css("top", o);
              } else {
                $("#j1-sidebar.affix").css("top", m);
              }
            });
        }
    }; // end return

  }();

{% endcapture %}

{{ j1_cache | strip_empty_lines }}
{% assign j1_cache = nil %}